; GUI #
;smooth.c - This program demonstrates smooth shading.
;A smooth shaded polygon is drawn in a 2-D projection.
include win64a.inc
; --------------- 
Wwd equ 400
Wht equ 400
POINTER      = 1
INTERLEAVED  = 2
DRAWARRAY    = 1
ARRAYELEMENT = 2
DRAWELEMENTS = 3
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX       ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	Wht
	push	Wwd
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
        
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
        cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx
        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmSIZE:; --------------- Resize the scene
        movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
	xor	eax,eax
        jmp	wmBYE
wmCREATE:invoke	GetDC  ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   )
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax; 
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax;  
	invoke	wglCreateContext,hDC;     OpenGL
	mov	hrc,rax
	invoke	wglMakeCurrent,hDC,eax;   
;GLInit-----------------------------------------
	movd	xmm3,ebx
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke  glClearColor
	invoke  glShadeModel,GL_SMOOTH
	invoke	setupPointers
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
	lea	edx,ps
        invoke  BeginPaint
        invoke  glClear, GL_COLOR_BUFFER_BIT
	cmp	derefMethod,DRAWARRAY
	jnz	@f
	invoke glDrawArrays, GL_TRIANGLES, 0, 6
	jmp	@0
@@:	cmp	derefMethod,ARRAYELEMENT
	jnz	@f
	invoke  glBegin, GL_TRIANGLES
	invoke  glArrayElement, 2
	invoke  glArrayElement, 3
	invoke  glArrayElement, 5
	invoke  glEnd
	jmp	@0
@@:     cmp	derefMethod,DRAWELEMENTS
	jnz	@0
	mov	r9d,offset indices
	invoke  glDrawElements,GL_POLYGON,4,GL_UNSIGNED_INT
@0:	invoke  glFlush
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
setupPointers proc
	invoke  glEnableClientState, GL_VERTEX_ARRAY
	invoke  glEnableClientState, GL_COLOR_ARRAY
	mov	r9d,offset vertices
	invoke  glVertexPointer,2,GL_INT,0
	mov	r9d,offset colors
	invoke  glColorPointer,3,GL_FLOAT,0
	leave
	ret
setupPointers endp
GLReshape proc	w:dword, h:dword
local resulta:QWORD
local resultb:QWORD

	mov	w,ecx
	mov	h,edx
	fninit
	invoke  glViewport, 0, 0,w,h
	invoke  glMatrixMode, GL_PROJECTION
	invoke  glLoadIdentity
	fild	w
	fstp    resulta
	fild	h
	fstp    resultb
	movq	xmm3,resultb
	movq	xmm2,rbx
	movq	xmm1,resulta
	movq	xmm0,rbx
	invoke  gluOrtho2D
	leave
	retn
GLReshape endp
hDC	dq	?
hrc	dq	?
setupMethod dd POINTER
derefMethod dd DRAWARRAY
indices     dd 0,1,3,4
vertices    dd 25,25,100,325,175,25,175,325,250,25,2 dup(325)

colors      dd 1.0,4 dup(0.2),1.0,0.8,1.0,0.2,3 dup(0.75),\
		 3 dup(0.35),3 dup(0.5)

intertwined dd 1.0,0.2,1.0,2 dup(100.0),0.0,1.0,2 dup(0.2),0.0,200.0,0.0,\
	 1.0,1.0,0.2,100.0,300.0,0.0,0.2,1.0,0.2,200.0,300.0,0.0,\
	 0.2,2 dup(1.0),300.0,200.0,0.0,2 dup(0.2),1.0,200.0,100.0,0.0

PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	0;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "OpenGL - Vertex Arrays",0
FileName	db "..\..\Images\br_Rabbit3.cur",0
const1_0	dd 1.0
const5_0	dd 5.0
const25_0	dd 25.0
constd30_0	dq 30.0
end